﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GaCa
{
	class CASettings
	{
		public enum Setting { Size, StatesPerCell, Neighborhood, Boundary, Interpretation, DevelopmentType }

		public int Size { get; set; }
		public Development.Boundary Boundary { get; set; }
		public int StatesPerCell { get; set; }
		public int Neighborhood { get; set; }
		public Development.Interpretation Interpretation { get; set; }
		public int Periods { get; set; }
		public int Threshold { get; set; }
		public Development.Type DevelopmentType { get; set; }
		public int Steps { get; set; }
		
		//public CASettings() : this(1)
		//{
		//}

		//public CASettings(int experiment)
		//{
		//    switch (experiment)
		//    {
		//        case 1:
		//            this.Size = 16;
		//            this.Boundary = Development.Boundary.Trap;
		//            this.StatesPerCell = 2;
		//            this.Neighborhood = 3;
		//            this.Interpretation = Development.Interpretation.Decimal;
		//            this.Threshold = 100;
		//            this.Periods = 10;
		//            break;
		//        case 2:
		//            this.Size = 128;
		//            this.Boundary = Development.Boundary.Cyclic;
		//            this.StatesPerCell = 2;
		//            this.Neighborhood = 3;
		//            this.Interpretation = Development.Interpretation.Sum;
		//            this.Threshold = 100;
		//            this.Periods = 1;
		//            break;
		//        case 3:
		//            this.Size = 4;
		//            this.Boundary = Development.Boundary.Cyclic;
		//            this.StatesPerCell = 8;
		//            this.Neighborhood = 3;
		//            this.Interpretation = Development.Interpretation.Sum;
		//            this.Threshold = 100;
		//            this.Periods = 10;
		//            break;
		//    }
		//}

		public Dictionary<Setting, string> Dictionary()
		{
			Dictionary<Setting, string> dict = new Dictionary<Setting, string>();
			dict.Add(Setting.Size, Size.ToString());
			dict.Add(Setting.StatesPerCell, StatesPerCell.ToString());
			dict.Add(Setting.Neighborhood, Neighborhood.ToString());
			dict.Add(Setting.Boundary, Boundary.ToString());
			dict.Add(Setting.Interpretation, Interpretation.ToString());
			//dict.Add(Setting.Periods, Periods.ToString());
			//dict.Add(Setting.Threshold, Threshold.ToString());
			dict.Add(Setting.DevelopmentType, DevelopmentType.ToString());
			return dict;
		}

		public CA GenerateCA()
		{
			return new CA(this);
		}

		public string GenerateState()
		{
			StringBuilder sb = new StringBuilder();
			for (int i = 0; i < Size; i++)
			{
				sb.Append(Tools.Random.Next(StatesPerCell));
			}
			return sb.ToString();
		}

		//public CA GenerateCA()
		//{
		//    StringBuilder sbRule = new StringBuilder();
		//    int length = (int)Tools.Pow(StatesPerCell, Neighborhood);
		//    for (int i = 0; i < length; i++)
		//        sbRule.Append(Tools.Random.Next(StatesPerCell));

		//    return new CA(sbRule.ToString(), this);
		//}
	}
}
