﻿//using System;
//using System.Collections.Generic;
//using System.Linq;
//using System.Text;

//namespace GaCa
//{
//    class ComplexGA
//    {
//        Random random;
//        Fitness fitness;
//        Development transformation;
//        List<CA> population;
//        int candidateCount;
//        int populationCount;
//        double mutationRate;
//        int caWidth;
//        int caTime;
//        int currentGeneration;
//        int clonesPerCandidate;

//        public ComplexGA(List<int> targetMagnitudes, int populationCount, int caWidth, int caTime)
//        {
//            this.random = new Random();
//            this.transformation = new Development();
//            this.caTime = caTime;
//            this.fitness = new Fitness(targetMagnitudes, caTime);
//            this.mutationRate = 0.05;
//            this.caWidth = caWidth;
//            this.population = GetPopulation(populationCount);
//            this.candidateCount = populationCount;
//            this.populationCount = populationCount;
//            this.currentGeneration = 0;
//            this.clonesPerCandidate = 4;
//        }

//        List<CA> GetPopulation(int count)
//        {
//            //Console.WriteLine("creating the population");
//            List<CA> population = new List<CA>();
//            for(int i = 0; i < count; i++)
//            {
//                population.Add(new CA(caWidth));
//            }
//            return population;
//        }

//        public void Step()
//        {
//            //Console.WriteLine("doing generation {0}. got {1} ca's: {2}", currentGeneration, population.Count, GetOutput(population));
//            List<CA> candidates = GetCandidates(population);
//            //Console.WriteLine("got {0} candidates: {1}", candidates.Count, GetOutput(candidates));
//            List<CA> clones = GetClones(candidates);
//            //Console.WriteLine("made {0} clones: {1}", clones.Count, GetOutput(clones));
//            List<CA> adults = GetAdults(population, clones);
//            //Console.WriteLine("picked {0} adults: {1}. done with generation {1}", adults.Count, GetOutput(adults), currentGeneration);
//            this.population = adults;
//            currentGeneration++;
//        }

//        List<CA> GetCandidates(List<CA> population)
//        {
//            Roulette roulette = new Roulette(fitness, population);
//            List<CA> candidates = new List<CA>();
//            for (int i = 0; i < populationCount; i++)
//            {
//                CA candidate = roulette.Announce();
//                candidates.Add(candidate);
//                //Console.WriteLine("found {0}", candidate);
//            }
//            return candidates;
//        }

//        List<CA> GetClones(List<CA> candidates)
//        {
//            List<CA> clones = new List<CA>();
//            foreach(CA candidate in candidates)
//            {
//                for (int i = 0; i < clonesPerCandidate; i++)
//                {
//                    CA mutant = Mutate(candidate);
//                    //Console.WriteLine("mutant: " + mutant);
//                    clones.Add(mutant);
//                }
//            }
//            return clones;
//        }

//        List<CA> GetAdults(List<CA> population, List<CA> clones)
//        {
//            fitness.Process(clones);
//            List<CA> adults = new List<CA>();
//            foreach (KeyValuePair<int, double> kvPair in fitness.GetFitnesses().OrderByDescending(key => key.Value))
//            {
//                adults.Add(clones[kvPair.Key]);
//                if (adults.Count >= populationCount)
//                    return adults;
//            }
//            return adults;
//        }

//        CA Mutate(CA ca)
//        {
//            string rule = ca.Rule;
//            string init = ca.Init;
//            //Console.WriteLine("original: " + ca.ToString());
//            if (random.NextDouble() < mutationRate)
//                rule = random.Next(256);
//            StringBuilder sb = new StringBuilder();
//            foreach (char c in init)
//                sb.Append(random.NextDouble() < mutationRate ? Tools.Swap(c) : c);
//            init = sb.ToString();
//            //Console.WriteLine("mutation: " + ca.ToString());
//            return new CA(rule, init);
//        }

//        public List<int> GetBestMagnitudes()
//        {
//            return fitness.GetBestMagnitudes();
//        }

//        public double GetBestScore()
//        {
//            return fitness.GetBestScore();
//        }

//        public CA GetBestCA()
//        {
//            return population[fitness.GetBestCAIndex()];
//        }

//        public double GetAverageFitness()
//        {
//            return fitness.GetAverageFitness();
//        }

//        public string GetOutput(List<CA> population)
//        {
//            StringBuilder sb = new StringBuilder();
//            foreach (CA ca in population)
//                sb.Append(ca.ToString()).AppendLine();
//            return sb.ToString();
//        }

//    }

//    class Roulette
//    {
//        List<CA> population;
//        double totalFitness;
//        double averageFitness;
//        //double standardDeviation;
//        Fitness fitness;
//        public Dictionary<int, double> roulette;
//        Random random;
//        //double totalScaledFitness;

//        public Roulette(Fitness fitness, List<CA> population)
//        {
//            this.random = new Random();
//            this.population = population;
//            this.fitness = fitness;
//            this.fitness.Process(population);
//            this.totalFitness = fitness.GetTotalFitness();
//            this.averageFitness = fitness.GetAverageFitness();
//            //this.standardDeviation = fitness.GetStandardDeviation();
//            //this.roulette = SigmaScale(fitness.GetFitnesses());
//            this.roulette = (fitness.GetFitnesses());
//        }

//        //Dictionary<int, double> SigmaScale(Dictionary<int, double> fitnesses)
//        //{
//        //    this.totalScaledFitness = 0;
//        //    for (int caIndex = 0; caIndex < fitnesses.Count; caIndex++)
//        //    {
//        //        double score = fitnesses[caIndex];
//        //        double scaledFitness = score - (averageFitness - 2 * standardDeviation);
//        //        fitnesses[caIndex] = scaledFitness;
//        //        this.totalScaledFitness += scaledFitness;
//        //    }
//        //    return fitnesses;
//        //}

//        public CA Announce()
//        {
//            double target = totalFitness * random.NextDouble();
//            double counter = 0.0;
//            for (int caIndex = 0; caIndex < roulette.Count(); caIndex++)
//            {
//                double fitness = roulette[caIndex];
//                counter += fitness;
//                //Console.WriteLine("target: {0}, counter: {1}", target, counter);
//                if (counter >= target)
//                {
//                    CA ca = population[caIndex];
//                    //Console.WriteLine("{0} ({1})", ca, fitness);
//                    return ca;
//                }
//            }
//            Console.WriteLine("this shouldn't happen. ");
//            return null;
//        }
//    }

//    class Fitness
//    {
//        Development transformation;
//        List<int> targetPoints;
//        int targetLength;
//        int caTime;
//        Dictionary<int, double> fitnesses;

//        double bestScore;
//        int bestCAIndex;
//        List<int> bestMagnitudes;

//        double totalFitness;
//        double averageFitness;
//        //double standardDeviation;

//        public Fitness(List<int> target, int caTime)
//        {
//            this.transformation = new Development();
//            this.caTime = caTime;
//            this.targetPoints = target;
//            this.targetLength = target.Count;
//        }

//        public void Process(List<CA> population)
//        {
//            this.bestScore = 0;
//            this.bestCAIndex = -1;
//            this.bestMagnitudes = null;
//            this.totalFitness = 0;
//            this.fitnesses = new Dictionary<int, double>();
//            for (int caIndex = 0; caIndex < population.Count; caIndex++)
//            {
//                CA ca = population[caIndex];
//                List<int> magnitudes = transformation.Develop(ca, caTime);
//                double score = Calculate(magnitudes);
//                this.fitnesses.Add(caIndex, score);
//                this.totalFitness += score;
//                if (score > bestScore)
//                {
//                    this.bestScore = score;
//                    this.bestMagnitudes = magnitudes;
//                    this.bestCAIndex = caIndex;
//                }
//            }
//            this.averageFitness = totalFitness / population.Count;
//            //this.standardDeviation = StandardDeviate(fitnesses, averageFitness);
//        }

//        //Dictionary<int, double> ScaleFitnesses(Dictionary<int, double> fitnesses, double averageFitness, double standardDeviation)
//        //{
//        //    this.totalScaledFitness = 0;
//        //    Dictionary<int, double> scaledFitnesses = new Dictionary<int, double>();
//        //    for (int caIndex = 0; caIndex < fitnesses.Count; caIndex++)
//        //    {
//        //        double score = fitnesses[caIndex];
//        //        double scaledFitness = score - (averageFitness - 2 * standardDeviation);
//        //        scaledFitnesses.Add(caIndex, scaledFitness);
//        //        this.totalScaledFitness += scaledFitness;
//        //    }
//        //    return scaledFitnesses;
//        //}

//        //double StandardDeviate(Dictionary<int, double> fitnesses, double averageFitness)
//        //{
//        //    double standardDeviation = 0;
//        //    for (int caIndex = 0; caIndex < fitnesses.Count; caIndex++)
//        //    {
//        //        double diff = fitnesses[caIndex] - averageFitness;
//        //        standardDeviation += diff * diff;
//        //    }
//        //    standardDeviation = Math.Sqrt(standardDeviation / fitnesses.Count);
//        //    if (standardDeviation == 0) standardDeviation = double.Epsilon;
//        //    return standardDeviation;
//        //}

//        public Dictionary<int, double> GetFitnesses()
//        {
//            return fitnesses;
//        }

//        public double Calculate(List<int> magnitudes)
//        {
//            //Console.WriteLine("length of target: {0}, length of candidate: {1}", targetPoints.Count, candidate.Count);
//            List<int> candidatePoints = magnitudes.GetRange(0, targetLength);
//            double difference = RootMeanSquaredError(candidatePoints);
//            return 1.0 / (1 + difference);
//        }

//        double MeanSquaredError(List<int> candidatePoints)
//        {
//            double MSE = 0.0;
//            for (int i = 0; i < targetLength; i++)
//            {
//                double diff = targetPoints[i] - candidatePoints[i];
//                MSE += diff * diff;
//            }
//            return MSE / targetLength;
//        }

//        double RootMeanSquaredError(List<int> candidatePoints)
//        {
//            return Math.Sqrt(MeanSquaredError(candidatePoints));
//        }

//        public List<int> GetBestMagnitudes()
//        {
//            return bestMagnitudes;
//        }

//        public double GetBestScore()
//        {
//            return bestScore;
//        }

//        public int GetBestCAIndex()
//        {
//            return bestCAIndex;
//        }

//        public double GetAverageFitness()
//        {
//            return averageFitness;
//        }

//        public double GetTotalFitness()
//        {
//            return totalFitness;
//        }

//        //public double GetStandardDeviation()
//        //{
//        //    return standardDeviation;
//        //}
//    }
//}
