﻿using System.Collections.Generic;
using System;

namespace GaCa
{

	class GraphFitness
	{

		List<int> target;
		int count;

		public GraphFitness(List<int> target)
		{
			this.target = target;
			this.count = target.Count;
		}

		public double Calculate(List<int> candidate)
		{
			//Console.WriteLine("t: " + target.Count + " c: " + candidate.Count);
			double MSE = 0.0;
			for (int i = 0; i < count; i++)
			{
				double diff = target[i] - candidate[i];
				MSE += diff * diff;
			}
			return 1.0 / (1 + Math.Sqrt(MSE / count));
		}

	}
}