﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Input;

namespace GaCa
{
	class Input
	{
		public enum Inputs { Space, MouseLeft, R, One, Two, Three, Four, Five, Six, Caps, Escape, F, Right, Left, Up, Down, D };

		private Dictionary<Inputs, bool> prev;
		private Dictionary<Inputs, bool> next;

		public Input()
		{
			prev = new Dictionary<Inputs, bool>();
			next = new Dictionary<Inputs, bool>();
			foreach (Inputs key in Enum.GetValues(typeof(Inputs)))
			{
				prev.Add(key, false);
				next.Add(key, false);
			}
		}

		public bool Pressed(Inputs key)
		{
			return (!prev[key] && next[key]);
		}

		public void Load()
		{
			next[Inputs.Space] = Keyboard.GetState().IsKeyDown(Keys.Space);
			next[Inputs.R] = Keyboard.GetState().IsKeyDown(Keys.R);
			next[Inputs.Caps] = Keyboard.GetState().IsKeyDown(Keys.CapsLock);
			next[Inputs.One] = Keyboard.GetState().IsKeyDown(Keys.D1);
			next[Inputs.Two] = Keyboard.GetState().IsKeyDown(Keys.D2);
			next[Inputs.Three] = Keyboard.GetState().IsKeyDown(Keys.D3);
			next[Inputs.Four] = Keyboard.GetState().IsKeyDown(Keys.D4);
			next[Inputs.Five] = Keyboard.GetState().IsKeyDown(Keys.D5);
			next[Inputs.Six] = Keyboard.GetState().IsKeyDown(Keys.D6);
			next[Inputs.Escape] = Keyboard.GetState().IsKeyDown(Keys.Escape);
			next[Inputs.MouseLeft] = Mouse.GetState().LeftButton == ButtonState.Pressed;
			next[Inputs.F] = Keyboard.GetState().IsKeyDown(Keys.F);
			next[Inputs.Right] = Keyboard.GetState().IsKeyDown(Keys.Right);
			next[Inputs.Left] = Keyboard.GetState().IsKeyDown(Keys.Left);
			next[Inputs.Up] = Keyboard.GetState().IsKeyDown(Keys.Up);
			next[Inputs.Down] = Keyboard.GetState().IsKeyDown(Keys.Down);
			next[Inputs.D] = Keyboard.GetState().IsKeyDown(Keys.D);
		}

		public void Save()
		{
			foreach (Inputs key in Enum.GetValues(typeof(Inputs)))
			{
				prev[key] = next[key];
			}
		}
	}


}
