﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GaCa
{
	class Menu
	{
		public CASettings Settings;

		public CASettings.Setting Current 
		{
			get
			{
				CASettings.Setting[] values = (CASettings.Setting[])Enum.GetValues(typeof(CASettings.Setting));
				return values[index % values.Length];
			}
		}

		int index;

		public Menu(CASettings settings)
		{
			this.Settings = settings;
			this.index = 0;
		}

		public void Next()
		{
			this.index++;
		}

		public void Prev()
		{
			this.index--;
		}

		public void Increase()
		{
			switch (Current)
			{
				case CASettings.Setting.StatesPerCell:
					Settings.StatesPerCell++;
					break;
				case CASettings.Setting.Neighborhood:
					Settings.Neighborhood += 2;
					break;
				case CASettings.Setting.Size:
					Settings.Size++;
					break;
				case CASettings.Setting.Boundary:
					Settings.Boundary = (Settings.Boundary == Development.Boundary.Cyclic ? Development.Boundary.Trap : Development.Boundary.Cyclic);
					break;
				case CASettings.Setting.Interpretation:
					Settings.Interpretation = (Settings.Interpretation == Development.Interpretation.Sum ? Development.Interpretation.Decimal : Development.Interpretation.Sum);
					break;
				//case CASettings.Setting.Threshold:
					//Settings.Threshold += 5;
					//break;
				//case CASettings.Setting.Periods:
					//Settings.Periods++;
					//break;
				case CASettings.Setting.DevelopmentType:
					Development.Type[] values = (Development.Type[])Enum.GetValues(typeof(Development.Type));
					int index = values.ToList().IndexOf(Settings.DevelopmentType);
					Settings.DevelopmentType = values[(index + 1) % values.Length];
					break;
			}
		}

		public void Decrease()
		{
			switch (Current)
			{
				case CASettings.Setting.StatesPerCell:
					Settings.StatesPerCell--;
					if (Settings.StatesPerCell < 1) Settings.StatesPerCell = 1;
					break;
				case CASettings.Setting.Neighborhood:
					Settings.Neighborhood -= 2;
					if (Settings.Neighborhood < 1) Settings.Neighborhood = 1;
					break;
				case CASettings.Setting.Size:
					Settings.Size--;
					if (Settings.Size < 1) Settings.Size = 1;
					break;
				case CASettings.Setting.Boundary:
					Settings.Boundary = (Settings.Boundary == Development.Boundary.Cyclic ? Development.Boundary.Trap : Development.Boundary.Cyclic);
					break;
				case CASettings.Setting.Interpretation:
					Settings.Interpretation = (Settings.Interpretation == Development.Interpretation.Sum ? Development.Interpretation.Decimal : Development.Interpretation.Sum);
					break;
				//case CASettings.Setting.Threshold:
				//    Settings.Threshold -= 5;
				//    if (Settings.Threshold < 0) Settings.Threshold = 0;
				//    break;
				//case CASettings.Setting.Periods:
				//    Settings.Periods--;
				//    if (Settings.Periods < 1) Settings.Periods = 1;
				//    break;
				case CASettings.Setting.DevelopmentType:
					Development.Type[] values = (Development.Type[])Enum.GetValues(typeof(Development.Type));
					int index = values.ToList().IndexOf(Settings.DevelopmentType);
					Settings.DevelopmentType = values[(index + values.Length - 1) % values.Length];
					break;
			}
		}

	}
}
