﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GaCa
{
	class MultiVariableFitness
	{
		List<double> target1;
		List<double> target2;
		List<double> target3;
		List<double> target4;
		List<double> target5;

		public MultiVariableFitness(List<double> t1, List<double> t2, List<double> t3, List<double> t4, List<double> t5)
		{
			target1 = t1;
			target2 = t2;
			target3 = t3;
			target4 = t4;
			target5 = t5;
		}

		public double Calculate(List<double> vars1, List<double> vars2, List<double> vars3, List<double> vars4, List<double> vars5)
		{
			double f1 = new VariableFitness(target1, VariableFitness.Comparison.StrictCount).Calculate(vars1);
			double f2 = new VariableFitness(target2, VariableFitness.Comparison.StrictCount).Calculate(vars2);
			double f3 = new VariableFitness(target3, VariableFitness.Comparison.StrictCount).Calculate(vars3);
			double f4 = new VariableFitness(target4, VariableFitness.Comparison.StrictCount).Calculate(vars4);
			double f5 = new VariableFitness(target5, VariableFitness.Comparison.StrictCount).Calculate(vars5);
			
			return (f1 + f2 + f3 + f4 + f5) / 5.0;
		}
	}
}
