﻿using System.Collections.Generic;
using System;

namespace GaCa
{

	class StateFitness
	{

		string initial;
		string final;
		int steps;
		//Development development;
		//int sum;

		public StateFitness(ESSettings esSettings)
		{
			this.initial = esSettings.InitialState;
			this.final = esSettings.FinalState;
			this.steps = esSettings.DevelopmentSteps;
			//this.development = new Development();
		}

		public double Calculate(CA ca)
		{
			Development development = new Development(ca);

			string current = this.initial;
			for (int i = 0; i < this.steps - 1; i++) // including initial!
			{
				string next = development.Next(current);
				current = next;
			}

			double MSE = 0.0;
			for (int i = 0; i < final.Length; i++)
			{
				int targetSignal = (int)Char.GetNumericValue(final[i]);
				int finalSignal = (int)Char.GetNumericValue(current[i]);
				double diff = targetSignal - finalSignal;
				MSE += diff * diff;
			}
			double fitness = 1 / (1 + MSE);
			return fitness;
		}

	}
}