﻿using System.Collections.Generic;
using System;

namespace GaCa
{

	class VariableFitness
	{

		public enum Comparison { StrictCount, FirstVariables }

		List<double> targetVariables;
		int varCount;
		Comparison type;

		public VariableFitness(List<double> targetVariables, Comparison type)
		{
			this.targetVariables = targetVariables;
			this.varCount = targetVariables.Count;
			this.type = type;
		}

		public double Calculate(List<double> candidateVariables)
		{

			if (type == Comparison.StrictCount)
			    if (candidateVariables.Count != varCount)
			        return 0;

			if (candidateVariables.Count < varCount)
				return 0;

			double MSE = 0.0;
			for (int i = 0; i < varCount; i++)
			{
				double diff = targetVariables[i] - candidateVariables[i];
				MSE += diff * diff;
			}
			return 1.0 / (1 + Math.Sqrt(MSE / varCount));
		}

	}
}