﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework;

namespace GaCa
{
	class Writer
	{
		SpriteBatch spriteBatch;
		SpriteFont font;
		public int Y { get; set; }
		public int X { get; set; }
		//public int Line { get; set { Y = 10 + (value - 1) * 20; } }
		bool console;

		public Writer(SpriteBatch spriteBatch, SpriteFont font)
		{
			this.spriteBatch = spriteBatch;
			this.font = font;
			this.Y = 10;
			this.X = 10;
			this.console = false;
		}

		public void Begin()
		{
			this.Y = 10;
			this.X = 10;
		}

		public void Console(bool console)
		{
			this.console = console;
		}

		//public void Init(int line)
		//{
		//    Y = 10 + (line - 1) * 20;
		//    X = 10;
		//}

		public void WriteLine()
		{
			X = 10;
			Y += 20;
		}

		public void WriteLine(string text, params object[] args)
		{
			WriteLine(Color.White, text, args);
		}

		public void WriteLine(Color color, string text, params object[] args)
		{
			string formatted = String.Format(text, args);
			spriteBatch.DrawString(font, formatted, new Vector2(X, Y), color);
			Y += 20;
			X = 10;
			if (console)
			{
				System.Console.WriteLine(formatted);
			}
		}

		public void Write(bool stillRun, string text)
		{
			Write(stillRun, Color.White, text);
		}

		public void Write(string text, params object[] args)
		{
			Write(false, Color.White, text, args);
		}

		public void Write(Color color, string text, params object[] args)
		{
			Write(false, color, text, args);
		}

		public void Write(bool stillRun, Color color, string text, params object[] args)
		{
			string formatted = String.Format(text, args);
			spriteBatch.DrawString(font, formatted, new Vector2(X, Y), color);
			if (console)
			{
				System.Console.Write(formatted);
			}
			if (!stillRun)
			{
				X += formatted.Length * 10 + 10;
				if (X > 600)
				{
					X = 10;
					Y += 20;
				}
			}
		}
	}
}
